#!/bin/bash

GCC_UID=""
QT_UID="UbuntuSDK-API-Qt"

case "$(dpkg-architecture -qDEB_HOST_MULTIARCH 2> /dev/null)" in
  x86_64-linux-gnu)
    GCC_UID="ProjectExplorer.ToolChain.Gcc:UbuntuSDKGCC-x86_64-linux-gnu"
    ./ubuntu-sdk-ide/bin/sdktool addTC \
      --id "${GCC_UID}" \
      --name "GCC (x86 64bit in /usr/bin/g++)" \
      --path /usr/bin/g++ \
      --abi x86-linux-generic-elf-64bit \
      --supportedAbis x86-linux-generic-elf-64bit,x86-linux-generic-elf-32bit
    ;;

  i386-linux-gnu)
    GCC_UID="ProjectExplorer.ToolChain.Gcc:UbuntuSDKGCC-x86-linux-generic-elf-32bit"
    ./ubuntu-sdk-ide/bin/sdktool addTC \
      --id "${GCC_UID}" \
      --name "GCC (x86 32bit in /usr/bin/g++)" \
      --path /usr/bin/g++ \
      --abi x86-linux-generic-elf-32bit \
      --supportedAbis x86-linux-generic-elf-32bit
    ;;

  *)
    echo "Unknown architecture"
    exit 1
    ;;
esac

./ubuntu-sdk-ide/bin/sdktool addQt \
    --id   "${QT_UID}" \
    --name "Ubuntu SDK Desktop Qt" \
    --qmake /usr/ubuntu-sdk-dev/bin/qmake \
    --type Qt4ProjectManager.QtVersion.Desktop

./ubuntu-sdk-ide/bin/sdktool addKit \
        --id "UbuntuSDK-API-Desktop-Kit" \
        --name "Ubuntu SDK Desktop Kit" \
        --debuggerengine 1 \
        --debugger /usr/bin/gdb \
        --devicetype Desktop \
        --toolchain "${GCC_UID}" \
        --qt "${QT_UID}"
